//Copyright (C) 2002  Daniel De Graaf
#ifndef Global_HEADER
#define Global_HEADER
//Version information is in '0.c'
//file input/output support is in io.h

#define OPTIMIZE_ROM_CALLS //makes it smaller
#define NO_EXIT_SUPPORT    //Don't need it
#define NO_AMS_CHECK       //Don't need it either
#define USE_TI89
#define USE_TI92PLUS
#include <tigcclib.h>

/***************\
| Useful Macros |
\***************/

///C extension///
//location in correct pointer type
#define loc(x) (typeof(x) *)(& x)

///Arguments///

//argument type
#define atype (*argptr)
//it must be type x
#define MustBe(x) if (atype != x) return

//Check and return OR replace with a default value
#define IntArgTo(x) do {             \
		if (atype != POSINT_TAG) return; \
		x = GetIntArg(argptr);           \
	} while (0)
#define OIntArgTo(x,y) x = (atype == POSINT_TAG) ? GetIntArg(argptr) : (y)
#define StrArgTo(x) do {             \
		if (atype != STR_TAG) return;    \
		x = GetStrnArg(argptr);          \
	} while (0)
#define OStrArgTo(x,y) x = (atype == STR_TAG) ? GetStrnArg(argptr) : (y)
#define SymArgTo(x) do {             \
		if (atype != STR_TAG) return;    \
		x = GetSymstrArg(argptr);        \
	} while (0)
#define OSymArgTo(x,y) x = (atype == STR_TAG) ? GetSymstrArg(argptr) : (y)

//Unsigned integer (return_to, type)
#define UIntArgTo(x,y) do {          \
		if (atype != POSINT_TAG &&       \
		    atype != NEGINT_TAG) return; \
		y = atype;                       \
		x = GetIntArg(argptr);           \
	} while (0)

//Bounded integer (return_to, low, high)
#define BIntArgTo(x,l,u) do {        \
		if (atype != POSINT_TAG) return; \
		x = min((unsigned)(u),           \
		    max((unsigned)(l),           \
		    GetIntArg(argptr)));         \
	} while (0)

// File functions
#define init(x) if (!_init(x,loc(ret))) return
	short _init(WORD size, BYTE** ret);
#define get_file(x,y)       \
	HANDLE fileh = _get_file(x, y, argptr); \
	if (!fileh) return
	HANDLE _get_file(BYTE, WORD*, BYTE*);
	SYM_ENTRY* get_file_sym(BYTE opt, BYTE* argptr);

// Return functions
#define return_int(x) _return_int(x,ret)
#define return_string(x) _return_str(x, strlen(x), STR_TAG, ret)
#define return_str(x,y,z) _return_str(x,y,z,ret)
#define return_bint(x,y) _return_bint(x,y,ret)
	void _return_int (DWORD, BYTE*);
	void _return_str (const char*, BYTE, BYTE, BYTE*);
	void _return_bint(const char*, BYTE, BYTE*);

HANDLE GetPopupMenu(char*, BYTE*);

//arguments with attribute unused
#define ___args___ \
	BYTE* argptr __attribute__ ((unused)), \
	BYTE* ret    __attribute__ ((unused))

#endif
