//Copyright (C) 2002  Daniel De Graaf

#include "Global.h"
#include "io.h"

static inline char* local_str(char* toadd) {
	SYM_ENTRY *sym=SymFindFirst(0,0);
	if (sym->name[0] != '0') return 0;
	while (sym->name[0] == '0') {
		sym=SymFindNext();
	}
	sym=SymFindPrev();
	//found last folder with '0???'
	char* lname=(sym->name);
	if (!toadd) return lname;
	char tlen=strlen(toadd);
	char* vname=malloc(tlen+9);
	vname[0]=0;
	memcpy(vname+1, lname, 4);      // is '0001'
	memcpy(vname+5, toadd, tlen+1); // should be '\x'
	return vname;
}

SYM_ENTRY* get_file_sym(BYTE opt __attribute__ ((unused)),
                        BYTE* str_end) {
	if (*str_end != STR_TAG) return 0;
	str_end -= 2; //pass STR_TAG and ending 0
#ifdef LOCAL_VARIN_SUPPORT
	BYTE* str_start=str_end;
	while (*str_start) str_start--; //scroll to start
	if (*str_start == '\\') { //local variable
		str_start=local_str(str_start);
		SYM_ENTRY* q=DerefSym(SymFind(str_start));
		free(str_start);
		return q;
	}
#endif
#ifdef FOLDER_VARIN_SUPPORT
	else if ((opt & 1) && (*str_end == '\\')) { //folder
		*str_end = 0; //so TI thinks it's the ending 0
		return DerefSym(SymFindHome(str_end));
	}
#endif
#ifdef TWIN_VARIN_SUPPORT
	else if ((opt & 2) && (*str_end == ':')) {  //twin
		*str_end = 0;
		SYM_ENTRY* q;
		if (!(q=DerefSym(SymFind(str_end)))) return 0;
		if (!q->flags.bits.twin) return 0; //must be a twin
		return loc(q[1]);
	}
#endif
	return SymFindPtr(str_end+1, 0); //normal variable
}
