//Copyright (C) 2002  Daniel De Graaf

#include "Global.h"
#include "io.h"

static inline char* local_str(char* toadd) {
	SYM_ENTRY *sym=SymFindFirst(0,0);
	if (sym->name[0] != '0') return 0;
	while (sym->name[0] == '0') {
		sym=SymFindNext();
	}
	sym=SymFindPrev();
	//found last folder with '0???'
	char* lname=(sym->name);
	if (!toadd) return lname;
	char tlen=strlen(toadd);
	char* vname=malloc(tlen+9);
	vname[0]=0;
	memcpy(vname+1, lname, 4);      // is '0001'
	memcpy(vname+5, toadd, tlen+1); // should be '\x'
	return vname;
}

short _init(WORD size, BYTE** a_ret) {
	BYTE* ret=*a_ret;
	if (ret == 0) return 0; //no name, no return
#ifdef LOCAL_VAROUT_SUPPORT
	BYTE* tmp;
	if (*ret == '\\') {
		if (!(tmp=ret=local_str(ret))) return 0; //not in local program
	} else
		tmp=0;
#endif
	while (*(++ret));
	SYM_ENTRY* ret_ptr;
	if ((ret_ptr=SymFindPtr(ret,0))) {
		if (ret_ptr->flags.flags_n & (SF_ARCHIVED + SF_TWIN + SF_LOCAL + SF_BUSY))
			return 0; //if it's one of these, don't touch!
		HeapFree(ret_ptr->handle); //free the data
	} else
		ret_ptr=DerefSym(SymAdd(ret)); //create symbol
#ifdef LOCAL_VAROUT_SUPPORT
	if (tmp) free(tmp); //if local_str was used
#endif
	if (!ret_ptr) return 0; //whoops
	ret = HeapDeref (ret_ptr->handle = HeapAlloc(size + 2)); //create data
	ret[0] = (size/256); //size
	ret[1] = size;
	*a_ret = ret + 2; //no write to size bytes
	return 1;
}
