//Copyright (C) 2002  Daniel De Graaf

#include "Global.h"

static inline void return_list(const char* lst, BYTE size, BYTE psize, BYTE* ret) {
	init(size //size of data
		+ ((size-1)/psize + 1) * 2 //size of int headers (round up)
		+ 2);
	ret[0]=END_TAG;
	while (size > 0) {
		register char cnt;
		for(cnt=0;cnt < psize && size > 0;cnt++)
			*(++ret)=lst[--size];
		*(++ret)=cnt;
		*(++ret)=POSINT_TAG;
	}
	ret[1]=LIST_TAG;
}

static inline BYTE get_str(BYTE* buf, BYTE* argptr) {
	BYTE size=0;
	while (*(--argptr) && size < 255) size++;
	memcpy(buf,++argptr,++size); //start past beginning zero
	return size;
}

static inline BYTE get_int(BYTE* buf, BYTE* argptr) {
	BYTE pos=0, size=*argptr;
	while (pos < size)
		buf[pos++] = *(--argptr);
	return size;
}

static inline BYTE get_list(BYTE* buf, BYTE isize, BYTE* argptr) {
	BYTE size=0;
	argptr--;
	while (size < 255 && atype == POSINT_TAG) {
		size++;
		SkipArg(argptr);
	}
	size *= isize;
	BYTE pos=0;
	while (pos < size) {
		unsigned long tmp = GetIntArg(argptr);
		if (isize == 4) {
			buf[pos++] = tmp / 0x1000000;
			buf[pos++] = tmp / 0x10000;
		} if (isize > 1)
			buf[pos++] = tmp / 0x100;
		buf[pos++] = tmp;
	}
	return size;
}

void F26(___args___) {
	BYTE size, from, to, buf[256]; //buffer allocated here
	{
		register BYTE* tmp=argptr;
			SkipArg(argptr); //deal with first argument last
			IntArgTo(from);
			IntArgTo(to);
		argptr = tmp - 1; //skip type byte
	}
	
	switch (from) {
		case 1 ... 3: //list
			size = get_list(buf, ((from == 3) ? 4 : from), argptr);
			break;
		case 4: //int
			size = get_int(buf, argptr);
			break;
		case 5: //str
			argptr--;
		case 6: //    and var
			size = get_str(buf, argptr);
			break;
		default:
			return;
	}	switch (to) {
		case 1 ... 3:
			return_list(buf, size, (to == 3) ? 4 : to, ret);
			break;
		case 4: //int
			return_bint(buf, size);
			break;
		case 5 ... 6: //str,var
			return_str(buf, size, STR_TAG*(to == 5)); //use STR_TAG if 5
			break;
	}
}
